
from OpenGL.GL import *

from cTexture import Texture

from cTimer import Timer

import math

class BaseCharacter:

	def __init__(self,pos):
		self.pos = pos
		self.tex = Texture.load(self.texturepath)
		self.stretch=1.0
		self.w = 1.0
		self.h = 1.0
		self.mirrored=1	#either 1 och -1. DONT do zero
		self.lean = 0  #for leaning when standing tall
	def draw(self):
		self.tex.setup()

		d = 1.0/64.0

		o=self.mirrored
		
		glPushMatrix()
		
		glTranslatef( self.pos[0], self.pos[1], 0)
		glScalef( 1+(0.5-self.stretch/2),self.stretch, 1)
		glColor4f(1,1,1,1)
		glBegin(GL_QUADS)
		glTexCoord((0+d)*o,(0+d)); glVertex2f(-.5,1)
		glTexCoord((1-d)*o,(0+d)); glVertex2f( .5,1)
		glTexCoord((1-d)*o,(1-d)); glVertex2f( .5,0)
		glTexCoord((0+d)*o,(1-d)); glVertex2f(-.5,0)
		glEnd()

		glPopMatrix()

	def move(self,(x,y)):
		newpos = [self.pos[0]+x,self.pos[1]+y]
		self.pos=newpos
		if(x<0):self.mirrored=-1
		if(x>0):self.mirrored=1
	
		if(x!=0):	#wobble wobble
			if(self.stretch>0.0):self.stretchy(math.sin((Timer.currentTime%1000-500)*3.14/180)*2)

	def stretchy(self,val):
		
		self.stretch+=val*Timer.diff

		if(val<0 and self.lean !=0):
			if(self.lean<0):self.lean+=Timer.diff*2
			if(self.lean>0):self.lean-=Timer.diff*2

		if(self.stretch < 0.5):self.stretch=0.5
		if(self.stretch > 1.5):self.stretch=1.5

		self.w=1+(0.5-self.stretch/2)
		self.h=self.stretch


	def leany(self,val):
		
		self.lean+=val*Timer.diff*2

		if(self.lean <= -0.8): self.lean=-0.8
		if(self.lean >= 0.8): self.lean=0.8

		if(self.lean<0):self.mirrored=-1
		if(self.lean>0):self.mirrored=1

	def morphback(self):
		
		val=1*Timer.diff

		leanval=2*Timer.diff

		if(self.stretch > 1.0):self.stretch-=val
		if(self.stretch < 1.0):self.stretch+=val

		if(self.lean > 0):self.lean-=leanval
		if(self.lean < 0):self.lean+=leanval

		self.w=1+(0.5-self.stretch/2)
		self.h=self.stretch