import pickle

class JoySettings:
	def __init__(self):
	
		axis = 0					#all numbers starting with 0 = axis, 1 = button
		button = 1					
	
		self.up = [axis,1,-1]		#axis, number 1, negative
		self.down = [axis,1,1]
		self.left = [axis,0,-1]
		self.right = [axis,0,1]
		
		self.special = [button,0]
		self.action = [button,1]
		
class KeySettings:
	def __init__(self):			

		self.up = 273
		self.down = 274
		self.left = 276
		self.right = 275
		
		self.special = 122
		self.action = 120

class Settings:
	def __init__(self):
	
		self.joy = JoySettings()
		self.keys = KeySettings()
	
		if not self.loadsettings("config.txt"):
		#if True:
			self.resolution = 0		#0 for 640x480, 1 for 800x600
			self.fullscreen = 0		#0 for fullscreen, 1 for windowed
			
			self.aalevel = 0.75			#value ranging between 0 and 1, for antialiasing
			self.musiclevel = 1			#value ranging between 0 and 1, for music level
			self.soundlevel = 0.25		#value ranging between 0 and 1, for sound level
			self.usejoy = 1				#value to use joystick. 0 = false
		
		

	def loadsettings(self,file):
	
		success=True
	
		
		try:
			f=open(file, 'r')
			self.resolution=pickle.load(f)
			self.fullscreen=pickle.load(f)
			self.joy=pickle.load(f)
			self.keys=pickle.load(f)
			self.aalevel=pickle.load(f)
			self.musiclevel=pickle.load(f)
			self.soundlevel=pickle.load(f)
			self.usejoy=pickle.load(f)
			f.close()
			print "Config loaded"
		except:
			success=False
			print "Config load failure"		#if the file can't be loaded correctly, standard settings will be assumed
	
	
		return success
		
	def savesettings(self,file):
		
		a=self.joy
		
		try:
			f=open(file, 'w')
			pickle.dump(self.resolution,f)
			pickle.dump(self.fullscreen,f)
			pickle.dump(self.joy,f)
			pickle.dump(self.keys,f)
			pickle.dump(self.aalevel,f)
			pickle.dump(self.musiclevel,f)
			pickle.dump(self.soundlevel,f)
			pickle.dump(self.usejoy,f)
			f.close()
			print "Config saved"
		except:
			print "save failure"
